## unifrac-tools 1.1.3

=== src/Makefile ===
.PHONY: all make api test test_binaries install clean rapi_test

CXX := h5c++

PLATFORM := $(shell uname -s)
COMPILER := $(shell ($(CXX) -v 2>&1) | tr A-Z a-z )

ifdef DEBUG
	ifneq (,$(findstring pgi,$(COMPILER)))
		OPT = -g
	else
		OPT = -O0 -DDEBUG=1 --debug -g -ggdb
	endif
else
	ifneq (,$(findstring pgi,$(COMPILER)))
		OPT = -fast
	else
	  ifneq (,$(findstring gcc,$(COMPILER)))
		OPT = -O4
		TGTFLAGS = -fwhole-program
	  else
		OPT = -O3
	  endif
	endif
endif

ifeq ($(PREFIX),)
	PREFIX := $(CONDA_PREFIX)
endif

ifeq ($(PLATFORM),Darwin)
	AVX2 := $(shell sysctl -a | grep -c AVX2)
	LDDFLAGS = -dynamiclib -install_name @rpath/libssu.so
else
	AVX2 := $(shell grep "^flags" /proc/cpuinfo | head -n 1 | grep -c avx2)
	LDDFLAGS = -shared
endif

EXEFLAGS =

ifneq (,$(findstring pgi,$(COMPILER)))
	MPFLAG =  -mp
else
	MPFLAG = -fopenmp
endif

LDDFLAGS += $(MPFLAG)
CPPFLAGS += $(MPFLAG)

UNIFRAC_FILES = unifrac_internal.o unifrac_cmp_cpu.o

ifndef NOGPU
	ifneq (,$(findstring pgi,$(COMPILER)))
		CPPFLAGS += -DUNIFRAC_ENABLE_ACC=1
                UNIFRAC_FILES += unifrac_cmp_acc.o
		ACCCPPFLAGS += -acc
	        ifeq ($(PERFORMING_CONDA_BUILD),True)
	            ACCCPPFLAGS += -ta=tesla:ccall
		else
	            ACCCPPFLAGS += -ta=tesla
                endif
		# optional info
		ACCCPPFLAGS += -Minfo=accel
	        LDDFLAGS += -shlib -acc -Bstatic_pgi
	        EXEFLAGS += -acc -Bstatic_pgi
	endif
endif

ifneq (,$(findstring pgi,$(COMPILER)))
	ifeq ($(PERFORMING_CONDA_BUILD),True)
		CPPFLAGS += -tp=sandybridge -Mvect=simd:256
	endif
else
	ifeq ($(PERFORMING_CONDA_BUILD),True)
		CPPFLAGS += -mtune=generic -mavx
	else
		CPPFLAGS += -mavx -mfma -march=native
	endif
endif

ifeq (,$(findstring pgi,$(COMPILER)))
	# basically, not gcc
	CPPFLAGS += -Wextra -Wno-unused-parameter
endif

BLASLIB=-llapacke -lcblas


CPPFLAGS += -Wall  -std=c++14 -pedantic -I. $(OPT) -fPIC -L$(PREFIX)/lib

all: api main install

main: ssu faithpd

api: libssu.so

test_binaries: test_su test_ska test_api

test_su: test_su.cpp tree.o test_su.cpp biom.o unifrac.o skbio_alt.o api.o $(UNIFRAC_FILES)
	$(CXX) $(CPPFLAGS) $(EXEFLAGS) test_su.cpp -o test_su tree.o biom.o $(UNIFRAC_FILES) unifrac.o skbio_alt.o api.o -llz4 $(BLASLIB) -lpthread
test_ska: test_ska.cpp tree.o test_su.cpp biom.o unifrac.o skbio_alt.o api.o $(UNIFRAC_FILES)
	$(CXX) $(CPPFLAGS) $(EXEFLAGS) test_ska.cpp -o test_ska skbio_alt.o tree.o biom.o $(UNIFRAC_FILES) unifrac.o api.o -llz4 $(BLASLIB) -lpthread
test_api: test_api.cpp tree.o test_su.cpp biom.o unifrac.o skbio_alt.o api.o $(UNIFRAC_FILES)
	$(CXX) $(CPPFLAGS) $(EXEFLAGS) test_api.cpp -o test_api tree.o biom.o $(UNIFRAC_FILES) unifrac.o skbio_alt.o api.o -llz4 $(BLASLIB) -lpthread

ssu: su.cpp tree.o biom.o unifrac.o cmd.o skbio_alt.o api.o $(UNIFRAC_FILES)
	$(CXX) $(CPPFLAGS) $(EXEFLAGS) su.cpp -o ssu tree.o biom.o $(UNIFRAC_FILES) unifrac.o cmd.o skbio_alt.o api.o -lhdf5_cpp -llz4 $(BLASLIB) -lpthread

faithpd: faithpd.cpp tree.o biom.o unifrac.o cmd.o skbio_alt.o api.o $(UNIFRAC_FILES)
	$(CXX) $(CPPFLAGS) $(EXEFLAGS) faithpd.cpp -o faithpd tree.o biom.o $(UNIFRAC_FILES) unifrac.o cmd.o skbio_alt.o api.o -lhdf5_cpp -llz4 $(BLASLIB) -lpthread

libssu.so: tree.o biom.o unifrac.o cmd.o skbio_alt.o api.o $(UNIFRAC_FILES)
	$(CXX) $(LDDFLAGS) -o libssu.so tree.o biom.o $(UNIFRAC_FILES) unifrac.o cmd.o skbio_alt.o api.o -lc -lhdf5_cpp -llz4 $(BLASLIB) -L$(PREFIX)/lib

api.o: api.cpp api.hpp unifrac.hpp skbio_alt.hpp biom.hpp tree.hpp
	$(CXX) $(CPPFLAGS) api.cpp -c -o api.o -fPIC

unifrac_cmp_cpu.o: unifrac_cmp.cpp unifrac_cmp.hpp unifrac_internal.hpp unifrac.hpp unifrac_task.cpp unifrac_task.hpp biom_interface.hpp tree.hpp
	$(CXX) $(CPPFLAGS) -c $< -o $@

unifrac_cmp_acc.o: unifrac_cmp.cpp unifrac_cmp.hpp unifrac_internal.hpp unifrac.hpp unifrac_task.cpp unifrac_task.hpp biom_interface.hpp tree.hpp
	$(CXX) $(CPPFLAGS) $(ACCCPPFLAGS) -c $< -o $@

%.o: %.cpp %.hpp
	$(CXX) $(CPPFLAGS) -c $< -o $@

test: test_binaries
	./test_su
	./test_ska
	./test_api

install: libssu.so ssu faithpd
	cp libssu.so ${PREFIX}/lib/
	cp ssu faithpd ${PREFIX}/bin/
	mkdir -p ${PREFIX}/include/unifrac
	cp task_parameters.hpp ${PREFIX}/include/unifrac/
	cp api.hpp ${PREFIX}/include/unifrac/
	cp status_enum.hpp ${PREFIX}/include/unifrac/

rapi_test: main
	mkdir -p ~/.R
	if [ -e ~/.R/Makevars ] ; \
	then \
		echo "WARNING: OVERWRITING ~/.R/Makevars" ; \
		echo "The original Makevars file has been copied to ~/.R/Makevars" ;\
		cp ~/.R/Makevars Makevars-original ; \
	fi;
	echo CXX1X=h5c++ > ~/.R/Makevars
	echo CXX=h5c++ >> ~/.R/Makevars 
	echo CC=h5c++ >> ~/.R/Makevars
	echo CFLAGS=  >> ~/.R/Makevars
	echo CXXFLAGS=  >> ~/.R/Makevars
	echo LDFLAGS= -llz4 $(BLASLIB) >> ~/.R/Makevars
	rm -f *.o
	Rscript R_interface/rapi_test.R
	rm -f *.o

clean:
	-rm -f *.o ssu faithpd test_su test_ska test_api libssu.so

## unifrac-tools 1.2

=== Makefile ===
.PHONY: all main api test_binaries test install clean

all: api main install

main:
	cd src && make main

api:
	cd src && make api

test_binaries:
	cd src && make test_binaries
	cd test && make test_binaries

test:
	cd src && make test
	cd test && make test

install:
	cd src && make install

clean:
	-cd test && make clean
	-cd src && make clean

=== src/Makefile ===
--- 
+++ 
@@ -58,9 +58,9 @@
 	            ACCCPPFLAGS += -ta=tesla:ccall
 		else
 	            ACCCPPFLAGS += -ta=tesla
+		    # optional info
+		    ACCCPPFLAGS += -Minfo=accel
                 endif
-		# optional info
-		ACCCPPFLAGS += -Minfo=accel
 	        LDDFLAGS += -shlib -acc -Bstatic_pgi
 	        EXEFLAGS += -acc -Bstatic_pgi
 	endif
@@ -79,8 +79,10 @@
 endif
 
 ifeq (,$(findstring pgi,$(COMPILER)))
+    ifneq ($(PERFORMING_CONDA_BUILD),True)
 	# basically, not gcc
 	CPPFLAGS += -Wextra -Wno-unused-parameter
+    endif
 endif
 
 BLASLIB=-llapacke -lcblas
@@ -110,7 +112,7 @@
 	$(CXX) $(CPPFLAGS) $(EXEFLAGS) faithpd.cpp -o faithpd tree.o biom.o $(UNIFRAC_FILES) unifrac.o cmd.o skbio_alt.o api.o -lhdf5_cpp -llz4 $(BLASLIB) -lpthread
 
 libssu.so: tree.o biom.o unifrac.o cmd.o skbio_alt.o api.o $(UNIFRAC_FILES)
-	$(CXX) $(LDDFLAGS) -o libssu.so tree.o biom.o $(UNIFRAC_FILES) unifrac.o cmd.o skbio_alt.o api.o -lc -lhdf5_cpp -llz4 $(BLASLIB) -L$(PREFIX)/lib
+	$(CXX) $(LDDFLAGS) -o libssu.so tree.o biom.o $(UNIFRAC_FILES) unifrac.o cmd.o skbio_alt.o api.o -lc -llz4 $(BLASLIB) -L$(PREFIX)/lib -noshlib -lhdf5_cpp -lhdf5_hl_cpp -lhdf5_hl -lhdf5
 
 api.o: api.cpp api.hpp unifrac.hpp skbio_alt.hpp biom.hpp tree.hpp
 	$(CXX) $(CPPFLAGS) api.cpp -c -o api.o -fPIC

=== test/Makefile ===
.PHONY: test_binaries test

CFLAGS := 
LDFLAGS :=

ifeq ($(PREFIX),)
	PREFIX := $(CONDA_PREFIX)
endif

test: capi_test
	./capi_test 1

test_binaries: capi_test

capi_test: capi_test.c
	$(CC) -std=c99 -O0 -g capi_test.c -I../src -lssu -L${PREFIX}/lib -Wl,-rpath,${PREFIX}/lib -o capi_test

clean:
	-rm -f *.o capi_test

=== debian/changelog ===
unifrac-tools (1.2-2) unstable; urgency=medium

  * Sneak in CFLAGS via CPPFLAGS to work around missing support of CLFAGS
    in upstream Makefile
    Closes: #1028051

 -- Andreas Tille <tille@debian.org>  Mon, 09 Jan 2023 08:31:31 +0100

unifrac-tools (1.2-1) unstable; urgency=medium

  [ Andreas Tille ]
  * Team Upload.
  * Fix Homepage
    Closes: #1026296
  * New upstream version
  * Standards-Version: 4.6.2 (routine-update)
  * Apply multi-arch hints. + libssu-dev: Add Multi-Arch: same.
  * Refresh patches

  [ Nilesh Patra ]
  * Do not pass -noshlib to ldflags
  * Add patch to enable debug flags

 -- Nilesh Patra <nilesh@debian.org>  Thu, 05 Jan 2023 22:09:46 +0530

unifrac-tools (1.1.3-2) unstable; urgency=medium

  * Team Upload.
  * Do not build unifrac-tools in parallel (Closes: #1026297)

 -- Nilesh Patra <nilesh@debian.org>  Sun, 18 Dec 2022 20:48:16 +0530

unifrac-tools (1.1.3-1) unstable; urgency=medium

  * Delete broken lintian-overrides
  * New upstream version

 -- Andreas Tille <tille@debian.org>  Wed, 30 Nov 2022 08:49:15 +0100

unifrac-tools (1.1.1-4) unstable; urgency=medium

  * Conflicts/Provides/Replaces: libssu-tools
    Closes: #1021284, #1021543

 -- Andreas Tille <tille@debian.org>  Mon, 10 Oct 2022 15:15:26 +0200

unifrac-tools (1.1.1-3) unstable; urgency=medium

  * baseline.patch: fix baseline violation and ftbfs on non-amd64.
    (Closes: #1021115)

 -- Étienne Mollier <emollier@debian.org>  Sun, 02 Oct 2022 15:31:39 +0200

unifrac-tools (1.1.1-2) unstable; urgency=medium

  * Source-only upload.
  * d/control: add myself to uploaders.
  * d/rules: activate the executable bit of executables; fix a test failure.

 -- Étienne Mollier <emollier@debian.org>  Sun, 02 Oct 2022 14:23:52 +0200

unifrac-tools (1.1.1-1) unstable; urgency=medium

  * Initial release (Closes: #1016160)

 -- Andreas Tille <tille@debian.org>  Thu, 28 Jul 2022 12:23:31 +0200

=== debian/control ===
Source: unifrac-tools
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Andreas Tille <tille@debian.org>,
           Étienne Mollier <emollier@debian.org>
Section: science
Testsuite: autopkgtest-pkg-python
Priority: optional
Build-Depends: debhelper-compat (= 13),
               dh-exec,
               libhdf5-dev,
               hdf5-helpers,
               liblz4-dev,
               libblas-dev,
               liblapacke-dev,
               chrpath,
               python3 <!nocheck>
Standards-Version: 4.6.2
Vcs-Browser: https://salsa.debian.org/med-team/unifrac-tools
Vcs-Git: https://salsa.debian.org/med-team/unifrac-tools.git
Homepage: https://github.com/biocore/unifrac-binaries
Rules-Requires-Root: no

Package: unifrac-tools
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends},
         libssu0
Conflicts: libssu-tools
Provides: libssu-tools
Replaces: libssu-tools
Description: high-performance phylogenetic diversity calculations (binaries)
 The de facto repository for high-performance phylogenetic diversity
 calculations. The methods in this repository are based on an
 implementation of the Strided State UniFrac algorithm which is faster,
 and uses less memory than Fast UniFrac. Strided State UniFrac supports
 Unweighted UniFrac, Weighted UniFrac, Generalized UniFrac, Variance
 Adjusted UniFrac and meta UniFrac. This repository also includes Stacked
 Faith (manuscript in preparation), a method for calculating Faith's PD
 that is faster and uses less memory than the Fast UniFrac-based
 reference implementation.
 .
 This package contains target binaries ssu and faithpd

Package: libssu0
Section: libs
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends}
Multi-Arch: same
Description: high-performance phylogenetic diversity calculations (lib)
 The de facto repository for high-performance phylogenetic diversity
 calculations. The methods in this repository are based on an
 implementation of the Strided State UniFrac algorithm which is faster,
 and uses less memory than Fast UniFrac. Strided State UniFrac supports
 Unweighted UniFrac, Weighted UniFrac, Generalized UniFrac, Variance
 Adjusted UniFrac and meta UniFrac. This repository also includes Stacked
 Faith (manuscript in preparation), a method for calculating Faith's PD
 that is faster and uses less memory than the Fast UniFrac-based
 reference implementation.
 .
 This package contains the shared library.

Package: libssu-dev
Architecture: any
Section: libdevel
Depends: libssu0 (= ${binary:Version}),
         ${shlibs:Depends},
         ${misc:Depends}
Multi-Arch: same
Description: high-performance phylogenetic diversity calculations (dev)
 The de facto repository for high-performance phylogenetic diversity
 calculations. The methods in this repository are based on an
 implementation of the Strided State UniFrac algorithm which is faster,
 and uses less memory than Fast UniFrac. Strided State UniFrac supports
 Unweighted UniFrac, Weighted UniFrac, Generalized UniFrac, Variance
 Adjusted UniFrac and meta UniFrac. This repository also includes Stacked
 Faith (manuscript in preparation), a method for calculating Faith's PD
 that is faster and uses less memory than the Fast UniFrac-based
 reference implementation.
 .
 This package contains the static library and header files.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/default.mk
export DEB_BUILD_MAINT_OPTIONS=hardening=+all
export PYBUILD_NAME=unifrac

export CPPFLAGS := $(CFLAGS) $(CPPFLAGS)

%:
	dh $@ --no-parallel

override_dh_auto_build:
	mkdir -p $(CURDIR)/debian/tmp/usr/bin
	mkdir -p $(CURDIR)/debian/tmp/usr/lib
	dh_auto_build -- PREFIX=$(CURDIR)/debian/tmp/usr
	chmod +x $(CURDIR)/debian/tmp/usr/bin/*

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	export PATH=${PATH}:$(CURDIR)/debian/tmp/usr/bin ; \
	cd ci ; \
	./crawford_test.sh
endif

override_dh_auto_install:
	mkdir -p $(CURDIR)/debian/tmp/usr/bin
	mkdir -p $(CURDIR)/debian/tmp/usr/lib
	dh_auto_install -- PREFIX=$(CURDIR)/debian/tmp/usr

override_dh_install:
	chrpath -d debian/tmp/usr/bin/ssu
	chrpath -d debian/tmp/usr/bin/faithpd
	chrpath -d debian/tmp/usr/lib/libssu.so*
	dh_install

## unifrac-tools 1.3.2

=== combined/Makefile ===
.PHONY: all api main install clean

all: api install

api: libssu.so

# no-op, just for completeness
main:


ifeq ($(PREFIX),)
    PREFIX := $(CONDA_PREFIX)
endif

libssu.o: libssu.c
	$(CC) -c libssu.c -fPIC

libssu.so: libssu.o
	$(CC) -shared -o libssu.so libssu.o -fPIC -ldl

install: libssu.so
	rm -f ${PREFIX}/lib//libssu.so; cp libssu.so ${PREFIX}/lib/
	rm -f ${PREFIX}/bin/ssu; cp ssu ${PREFIX}/bin/
	rm -f ${PREFIX}/bin/faithpd; cp faithpd ${PREFIX}/bin/

clean:
	rm -f libssu.o libssu.so

=== src/Makefile ===
.PHONY: all main api test test_binaries install clean rapi_test

CXX := h5c++

PLATFORM := $(shell uname -s)
COMPILER := $(shell ($(CXX) -v 2>&1) | tr A-Z a-z )

ifeq ($(BUILD_VARIANT),)
	SSU = ssu
	FPD = faithpd
else
	SSU = ssu_$(BUILD_VARIANT)
	FPD = faithpd_$(BUILD_VARIANT)
endif

ifdef DEBUG
	ifneq (,$(findstring pgi,$(COMPILER)))
		OPT = -g
	else
		OPT = -O0 -DDEBUG=1 --debug -g -ggdb
	endif
else
	ifneq (,$(findstring pgi,$(COMPILER)))
		OPT = -fast
	else
	  ifneq (,$(findstring gcc,$(COMPILER)))
		OPT = -Ofast
		TGTFLAGS = -fwhole-program
	  else
		OPT = -O3
	  endif
	endif
endif

ifeq ($(PREFIX),)
	PREFIX := $(CONDA_PREFIX)
endif

BLASLIB=-llapacke -lcblas

ifeq ($(PLATFORM),Darwin)
	AVX2 := $(shell sysctl -a | grep -c AVX2)
	LDDFLAGS = -dynamiclib -install_name @rpath/lib$(SSU).so
else
	AVX2 := $(shell grep "^flags" /proc/cpuinfo | head -n 1 | grep -c avx2)
	LDDFLAGS = -shared
	BLASLIB += -lgfortran -lquadmath
endif

EXEFLAGS =

ifneq (,$(findstring pgi,$(COMPILER)))
	MPFLAG =  -mp
else
	MPFLAG = -fopenmp
endif

LDDFLAGS += $(MPFLAG)
CPPFLAGS += $(MPFLAG)

UNIFRAC_FILES = unifrac_internal.o unifrac_cmp_cpu.o

ifndef NOGPU
	ifneq (,$(findstring pgi,$(COMPILER)))
		CPPFLAGS += -DUNIFRAC_ENABLE_ACC=1
                UNIFRAC_FILES += unifrac_cmp_acc.o
		ACCCPPFLAGS += -acc
	        ifeq ($(PERFORMING_CONDA_BUILD),True)
	            ACCCPPFLAGS += -ta=tesla:ccall
		else
	            ACCCPPFLAGS += -ta=tesla
		    # optional info
		    ACCCPPFLAGS += -Minfo=accel
                endif
	        LDDFLAGS += -shlib -acc -Bstatic_pgi
	        EXEFLAGS += -acc -Bstatic_pgi
	endif
endif

ifneq ($(BUILD_FULL_OPTIMIZATION),False)
    ifneq (,$(findstring pgi,$(COMPILER)))
	ifeq ($(PERFORMING_CONDA_BUILD),True)
		# enable avx2
		CPPFLAGS += -tp=haswell -Mvect=simd:256
	endif
    else
	ifeq ($(PERFORMING_CONDA_BUILD),True)
	   ifeq ($(PLATFORM),Darwin)
		CPPFLAGS += -mpopcnt
	   else
		# enable avx2
		CPPFLAGS += -march=haswell -mtune=znver2
	   endif
	else
		CPPFLAGS += -march=native -mtune=native
	endif
    endif
else
    ifneq (,$(findstring pgi,$(COMPILER)))
	ifeq ($(PERFORMING_CONDA_BUILD),True)
		# PGI does not support anything older than sandybridge
		CPPFLAGS += -tp=sandybridge -Mvect=simd:256
	endif
    else
	ifeq ($(PERFORMING_CONDA_BUILD),True)
		CPPFLAGS += -mtune=core2
	else
		CPPFLAGS += -march=native -mtune=native
	endif
    endif
endif

ifeq (,$(findstring pgi,$(COMPILER)))
    ifneq ($(PERFORMING_CONDA_BUILD),True)
	# basically, not gcc
	CPPFLAGS += -Wextra -Wno-unused-parameter
    endif
endif


CPPFLAGS += -Wall  -std=c++14 -pedantic -I. $(OPT) -fPIC -L$(PREFIX)/lib

all: api main install

main: $(SSU) $(FPD)

api: lib$(SSU).so

test_binaries: test_su test_ska test_api

test_su: test_su.cpp tree.o tsv.o test_su.cpp biom.o biom_inmem.o biom_subsampled.o unifrac.o skbio_alt.o api.o $(UNIFRAC_FILES)
	$(CXX) $(CPPFLAGS) $(EXEFLAGS) test_su.cpp -o test_su tree.o biom.o biom_inmem.o biom_subsampled.o tsv.o $(UNIFRAC_FILES) unifrac.o skbio_alt.o api.o -llz4 $(BLASLIB) -lpthread
test_ska: test_ska.cpp tree.o tsv.o test_su.cpp biom.o biom_inmem.o biom_subsampled.o unifrac.o skbio_alt.o api.o $(UNIFRAC_FILES)
	$(CXX) $(CPPFLAGS) $(EXEFLAGS) test_ska.cpp -o test_ska skbio_alt.o tree.o biom.o biom_inmem.o biom_subsampled.o tsv.o $(UNIFRAC_FILES) unifrac.o api.o -llz4 $(BLASLIB) -lpthread
test_api: test_api.cpp tree.o tsv.o test_su.cpp biom.o biom_inmem.o biom_subsampled.o unifrac.o skbio_alt.o api.o $(UNIFRAC_FILES)
	$(CXX) $(CPPFLAGS) $(EXEFLAGS) test_api.cpp -o test_api tree.o biom.o biom_inmem.o biom_subsampled.o tsv.o $(UNIFRAC_FILES) unifrac.o skbio_alt.o api.o -llz4 $(BLASLIB) -lpthread

$(SSU): su.cpp tree.o biom.o biom_inmem.o biom_subsampled.o tsv.o unifrac.o cmd.o skbio_alt.o api.o $(UNIFRAC_FILES)
	$(CXX) $(CPPFLAGS) $(EXEFLAGS) su.cpp -o $(SSU) tree.o biom.o biom_inmem.o biom_subsampled.o tsv.o $(UNIFRAC_FILES) unifrac.o cmd.o skbio_alt.o api.o -lhdf5_cpp -llz4 $(BLASLIB) -lpthread

$(FPD): faithpd.cpp tree.o biom.o biom_inmem.o biom_subsampled.o tsv.o unifrac.o cmd.o skbio_alt.o api.o $(UNIFRAC_FILES)
	$(CXX) $(CPPFLAGS) $(EXEFLAGS) faithpd.cpp -o $(FPD) tree.o biom.o biom_inmem.o biom_subsampled.o tsv.o $(UNIFRAC_FILES) unifrac.o cmd.o skbio_alt.o api.o -lhdf5_cpp -llz4 $(BLASLIB) -lpthread

lib$(SSU).so: tree.o biom.o biom_inmem.o biom_subsampled.o tsv.o unifrac.o cmd.o skbio_alt.o api.o $(UNIFRAC_FILES)
	$(CXX) $(LDDFLAGS) -o lib$(SSU).so tree.o biom.o biom_inmem.o biom_subsampled.o tsv.o $(UNIFRAC_FILES) unifrac.o cmd.o skbio_alt.o api.o -lc -llz4 $(BLASLIB) -L$(PREFIX)/lib -noshlib -lhdf5_cpp -lhdf5_hl_cpp -lhdf5_hl -lhdf5

api.o: api.cpp api.hpp unifrac.hpp skbio_alt.hpp biom.hpp biom_inmem.hpp biom_subsampled.hpp tree.hpp tsv.hpp
	$(CXX) $(CPPFLAGS) api.cpp -c -o api.o -fPIC

unifrac_cmp_cpu.o: unifrac_cmp.cpp unifrac_cmp.hpp unifrac_internal.hpp unifrac.hpp unifrac_task.cpp unifrac_task.hpp biom_interface.hpp tree.hpp
	$(CXX) $(CPPFLAGS) -c $< -o $@

unifrac_cmp_acc.o: unifrac_cmp.cpp unifrac_cmp.hpp unifrac_internal.hpp unifrac.hpp unifrac_task.cpp unifrac_task.hpp biom_interface.hpp tree.hpp
	$(CXX) $(CPPFLAGS) $(ACCCPPFLAGS) -c $< -o $@

%.o: %.cpp %.hpp
	$(CXX) $(CPPFLAGS) -c $< -o $@

test: test_binaries
	./test_su
	./test_ska
	./test_api

install: lib$(SSU).so $(SSU) $(FPD)
	rm -f ${PREFIX}/lib//lib$(SSU).so; cp lib$(SSU).so ${PREFIX}/lib/
	rm -f ${PREFIX}/bin/$(SSU); cp $(SSU) ${PREFIX}/bin/
	rm -f ${PREFIX}/bin/$(FPD); cp $(FPD) ${PREFIX}/bin/
	mkdir -p ${PREFIX}/include/unifrac
	rm -f ${PREFIX}/include/unifrac/task_parameters.hpp; cp task_parameters.hpp ${PREFIX}/include/unifrac/
	rm -f ${PREFIX}/include/unifrac/api.hpp; cp api.hpp ${PREFIX}/include/unifrac/
	rm -f ${PREFIX}/include/unifrac/status_enum.hpp; cp status_enum.hpp ${PREFIX}/include/unifrac/

rapi_test: main
	mkdir -p ~/.R
	if [ -e ~/.R/Makevars ] ; \
	then \
		echo "WARNING: OVERWRITING ~/.R/Makevars" ; \
		echo "The original Makevars file has been copied to ~/.R/Makevars" ;\
		cp ~/.R/Makevars Makevars-original ; \
	fi;
	echo CXX1X=h5c++ > ~/.R/Makevars
	echo CXX=h5c++ >> ~/.R/Makevars 
	echo CC=h5c++ >> ~/.R/Makevars
	echo CFLAGS=  >> ~/.R/Makevars
	echo CXXFLAGS=  >> ~/.R/Makevars
	echo LDFLAGS= -llz4 $(BLASLIB) >> ~/.R/Makevars
	rm -f *.o
	Rscript --verbose R_interface/rapi_test.R
	rm -f *.o

clean:
	-rm -f *.o $(SSU) $(FPD) test_su test_ska test_api lib$(SSU).so

=== debian/changelog ===
unifrac-tools (1.3.2-5) unstable; urgency=medium

  * Team upload.
  * Add patch to improve build hardening.

 -- Michael R. Crusoe <crusoe@debian.org>  Thu, 17 Aug 2023 17:01:48 +0200

unifrac-tools (1.3.2-4) unstable; urgency=medium

  * Team upload.
  * Adapt baseline patch even further to enable building on non-x86.

 -- Michael R. Crusoe <crusoe@debian.org>  Thu, 17 Aug 2023 14:54:08 +0200

unifrac-tools (1.3.2-3) unstable; urgency=medium

  [ Adrian Bunk ]
  * Fix baseline violation on amd64 and FTBFS everywhere else

 -- Andreas Tille <tille@debian.org>  Wed, 26 Jul 2023 06:47:41 +0200

unifrac-tools (1.3.2-2) unstable; urgency=medium

  * gcc-13.patch: new: fix build failures with gcc-13 (Closes: #1037879)

 -- Étienne Mollier <emollier@debian.org>  Sun, 23 Jul 2023 11:43:01 +0200

unifrac-tools (1.3.2-1) unstable; urgency=medium

  * New upstream version

 -- Andreas Tille <tille@debian.org>  Thu, 13 Jul 2023 14:28:35 +0200

## unifrac-tools 1.4

=== Makefile ===
.PHONY: test clean all

# Note: This Makefile will NOT properly work with the -j option 

PLATFORM := $(shell uname -s)
COMPILER := $(shell ($(CXX) -v 2>&1) | tr A-Z a-z )

ifeq ($(PLATFORM),Darwin)
all: api main install test_binaries

else

# Note: important that all_nv is after all_cpu_basic and all_nv_avx2 for tests to work
all: all_cpu_basic all_nv_avx2 all_nv all_combined test_binaries_nv

all_cpu_basic: api_cpu_basic main_cpu_basic install_cpu_basic

all_nv: api_nv main_nv install_nv

all_nv_avx2: api_nv_avx2 main_nv_avx2 install_nv_avx2

all_combined: api_combined install_combined

endif

clean:
	-cd test && make clean
	-cd src && make clean
	-cd combined && make clean

########### api

api:
	cd src && make api

api_cpu_basic:
	export BUILD_VARIANT=cpu_basic ; export BUILD_FULL_OPTIMIZATION=False ; cd src && make clean && make api

api_nv:
	source ./setup_nv_h5.sh; export BUILD_VARIANT=nv ; export BUILD_FULL_OPTIMIZATION=False ; cd src && make clean && make api

api_nv_avx2:
	source ./setup_nv_h5.sh; export BUILD_VARIANT=nv_avx2 ; export BUILD_FULL_OPTIMIZATION=True ; cd src && make clean && make api

api_combined:
	cd combined && make api

########### main

main:
	cd src && make main

main_cpu_basic:
	export BUILD_VARIANT=cpu_basic ; export BUILD_FULL_OPTIMIZATION=False ; cd src && make main

main_nv:
	source ./setup_nv_h5.sh; export BUILD_VARIANT=nv ; export BUILD_FULL_OPTIMIZATION=False ; cd src && make main

main_nv_avx2:
	source ./setup_nv_h5.sh; export BUILD_VARIANT=nv_avx2 ; export BUILD_FULL_OPTIMIZATION=True ; cd src && make main

########### install

install:
	cd src && make install

install_cpu_basic:
	export BUILD_VARIANT=cpu_basic ; export BUILD_FULL_OPTIMIZATION=False ; cd src && make install

install_nv:
	source ./setup_nv_h5.sh; export BUILD_VARIANT=nv ; export BUILD_FULL_OPTIMIZATION=False ; cd src && make install

install_nv_avx2:
	source ./setup_nv_h5.sh; export BUILD_VARIANT=nv_avx2 ; export BUILD_FULL_OPTIMIZATION=True ; cd src && make install

install_combined:
	cd combined && make install

########### test

test_binaries:
	cd src && make test_binaries
	cd test && make test_binaries

test_binaries_nv:
	source ./setup_nv_h5.sh; export BUILD_VARIANT=nv ; export BUILD_FULL_OPTIMIZATION=False ; cd src && make test_binaries
	# use the default compiler for the test subdir as it tests the combined shlib
	cd test && make test_binaries

test:
	cd src && make test
	cd test && make test

=== combined/Makefile ===
--- 
+++ 
@@ -13,10 +13,10 @@
 endif
 
 libssu.o: libssu.c
-	$(CC) -c libssu.c -fPIC
+	$(CC) $(CPPFLAGS) $(CFLAGS) -c libssu.c -fPIC
 
 libssu.so: libssu.o
-	$(CC) -shared -o libssu.so libssu.o -fPIC -ldl
+	$(CC) -shared -o libssu.so libssu.o -fPIC -ldl $(LDFLAGS)
 
 install: libssu.so
 	rm -f ${PREFIX}/lib//libssu.so; cp libssu.so ${PREFIX}/lib/

=== src/Makefile ===
--- 
+++ 
@@ -118,7 +118,7 @@
 endif
 
 
-CPPFLAGS += -Wall  -std=c++14 -pedantic -I. $(OPT) -fPIC -L$(PREFIX)/lib
+CPPFLAGS += -Wall  -std=c++17 -pedantic -I. $(OPT) -fPIC -L$(PREFIX)/lib
 
 all: api main install

=== test/Makefile ===
.PHONY: test_binaries test

CFLAGS := 
LDFLAGS :=

ifeq ($(PREFIX),)
	PREFIX := $(CONDA_PREFIX)
endif

test: capi_test
	./capi_test 1

test_binaries: capi_test

capi_test: capi_test.c
	$(CC) $(CFLAGS) -std=c99 -O0 -g capi_test.c -I../src -lssu -L${PREFIX}/lib -Wl,-rpath,${PREFIX}/lib $(LDFLAGS) -o capi_test

clean:
	-rm -f *.o capi_test

=== debian/changelog ===
unifrac-tools (1.4-3) unstable; urgency=medium

  * d/clean: new: clean build artifacts. (Closes: #1048281)

 -- Étienne Mollier <emollier@debian.org>  Sun, 03 Dec 2023 13:21:32 +0100

unifrac-tools (1.4-2) unstable; urgency=medium

  * Team Upload.
  * Backport upstream patch to fix FTBFS in unifrac 1.3.

 -- Nilesh Patra <nilesh@debian.org>  Tue, 24 Oct 2023 04:03:49 +0530

unifrac-tools (1.4-1) unstable; urgency=medium

  * Team Upload.
  * New upstream version 1.4
  * Drop gcc-13.patch
  * Refresh/re-diff patches with new version

 -- Nilesh Patra <nilesh@debian.org>  Tue, 24 Oct 2023 00:51:49 +0530

=== debian/control ===
--- 
+++ 
@@ -13,6 +13,7 @@
                libblas-dev,
                liblapacke-dev,
                chrpath,
+               gfortran,
                python3 <!nocheck>
 Standards-Version: 4.6.2
 Vcs-Browser: https://salsa.debian.org/med-team/unifrac-tools

=== debian/watch ===
version=4

opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%@PACKAGE@-$1.tar.gz%" \
https://github.com/biocore/unifrac-binaries/tags .*/v?@ANY_VERSION@\.tar\.gz
